<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 23B.40</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .div-background-picture {
        background-image: url("LuckyDiceImagesv2023Feb/cover.jpg");
        background-position: center;
        background-repeat: no-repeat;
        background-size: cover;
        opacity: 0.9;
        height: 75px;
        display: block;
        width: 100%;
      };

    </style>
</head>
<body>
    <div class="container ">
        <div class="row div-background-picture ">
        </div>
        <div class="row  ">
            <div class="col-sm-5 form-group">
                <div class="row justify-content-center form-group">
                    <h4>Nhập Thông Tin Của Bạn</h4>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3 ">
                        <label >Username</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text"  id="inp-username" class="form-control" placeholder="nhập username">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3 ">
                        <label >Firstname</label>
                    </div>
                    <div class="col-sm-9 ">
                        <input type="text"  id="inp-firstname" class="form-control" placeholder="nhập firstname">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3 ">
                        <label >Lastname</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text"  id="inp-lastname" class="form-control" placeholder="nhập lastname">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 form-group">
                <div class="row justify-content-center" style="margin: 5px;">
                    <button class="btn btn-success " id="btn-newdice" >Ném new dice</button>
                </div>
                <div class="row  justify-content-center" style="margin: 5px;">
                    <img src="LuckyDiceImagesv2023Feb/dice.png" alt="ném xúc xắc" width="30%" height="100px" id="img-dice">
                </div>
                <div class="row justify-content-center" style="margin: 5px;">
                    <h3 id="id-loinhan">chúc mừng</h3>
                </div>
            </div>
            <div class="col-sm-3">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="row justify-content-center">
                            <p>Voucher</p>
                        </div>
                        <div class="row justify-content-center">
                            <p id="ma-giam-gia">ID2210</p>
                        </div>
                        <div class="row justify-content-center">
                            <p id="phan-tram-giam-gia">20%</p>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <img src="LuckyDiceImagesv2023Feb/xe-may.jpg" alt="giải thưởng" width="100%" height="200px" id="img-prize">
                </div>
            </div>
        </div>
        <div class="row " style="margin: 5px;">
            <div class="col-sm-5"></div>
            <div class="col-sm-7">
                <button class="btn btn-success" id="btn-dicehistory" >Dice History</button>
                <button class="btn btn-primary">Voucher History</button>
                <button class="btn btn-primary">Present History</button>
            </div>
        </div>
        <div class="row ">
                <table class="table text-center" id="history-placeholder-table">
                    <thead>
                        <tr>
                            <th>lượt#history-placeholder-table</th>
                            <th>Dice</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
        </div>
    </div>
</body>
<script>
    "use strict"
    // biến chung
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //hàm event
    $("#btn-newdice").click(function() {
        onBtnNemNewDiceClick();
    })
    $("#btn-dicehistory").click(function () {
        onBtnDiceHistoryClick();
    })
    function onBtnNemNewDiceClick() {
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };
        thuThapThongTin(vUserObj);
        if (validateThongTin(vUserObj) === 1){
            var vXmlHttpDice = new XMLHttpRequest();
            callAPIObj(vXmlHttpDice);
            xuLyHienThi(vXmlHttpDice,vUserObj);
        }
    }
    function onBtnDiceHistoryClick(){
        var vDiceHistoryObj = {
            username: ""
        };
        getDiceHistory(vDiceHistoryObj);
        if (validateDiceHistory(vDiceHistoryObj) === 1){
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            callAPIDiceHistory(vDiceHistoryObj,vXmlHttpDiceHistory);
            xuLyHienThiDiceHistory(vXmlHttpDiceHistory)
        }
    }
    //hàm chung
    function thuThapThongTin(paramObj){
        paramObj.username = $("#inp-username").val().trim();
        paramObj.firstname = $("#inp-firstname").val().trim();
        paramObj.lastname = $("#inp-lastname").val().trim();
    }
    function validateThongTin(paramObj) {
        if(paramObj.username === "") {
            alert("username chưa được nhập");
        }else if(paramObj.firstname === ""){
            alert("firstname chưa được nhập");
        }else if(paramObj.lastname === ""){
            alert("lastname chưa được nhập");
        }else return 1;
    }
    function callAPIObj(paramXmlHttp){
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
    }
    function xuLyHienThi(paramXmlHttp,paramObj){
        paramXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                console.log(paramXmlHttp.responseText);
                // parsing to object
                var vResponse = JSON.parse(paramXmlHttp.responseText);
                // get result dice
                var vDiceReady = vResponse.dice;
                console.log("dice result:= " + vDiceReady);
                var vImgDice =  $("#img-dice")[0];
                var vLoiNhan =  $("#id-loinhan")[0];
                if (vDiceReady === 1){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/1.png"
                }else if (vDiceReady === 2){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/2.png"
                }else if (vDiceReady === 3){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/3.png"
                }else if (vDiceReady === 4){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/4.png"
                }else if (vDiceReady === 5){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/5.png"
                }else if (vDiceReady === 6){
                    vImgDice.src = "LuckyDiceImagesv2023Feb/6.png"
                } 
                if (vResponse.prize === null && vResponse.voucher === null){
                    vLoiNhan.innerHTML = "Chúc bạn may mắn lần sau"
                }else {
                    vLoiNhan.innerHTML = "Chúc mừng"
                }
                var vMaGiamGia =  $("#ma-giam-gia")[0];
                var vPhanTramGiamGia = $("#phan-tram-giam-gia")[0];
                var vPrize = $("#img-prize")[0];
                if (vResponse.voucher !== null ){
                    vMaGiamGia.innerHTML = vResponse.voucher.maVoucher;
                    vPhanTramGiamGia.innerHTML = vResponse.voucher.phanTramGiamGia;
                }else {
                    vMaGiamGia.innerHTML = "không có";
                    vPhanTramGiamGia.innerHTML = "không có"; 
                }
                if (vResponse.prize !== null) {
                    if (vResponse.prize === "Áo mưa"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/ao-mua.jpg"
                    }else if (vResponse.prize === "Xe máy"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/xe-may.jpg"
                    }else if (vResponse.prize === "Mũ"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/hat.jpg"
                    }else if (vResponse.prize === "Sổ"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/book.jpg"
                    }else if (vResponse.prize === "Bút"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/but.png"
                    }else if (vResponse.prize === "Áo thun"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/t-shirt.jpg"
                    }else if (vResponse.prize === "Ô tô"){
                        vPrize.src = "LuckyDiceImagesv2023Feb/car.jpg"
                    }
                    
                }else {
                    vPrize.src = "LuckyDiceImagesv2023Feb/no-present.jpg"
                }
            }
        }
        paramXmlHttp.send(JSON.stringify(paramObj));  //chuyển Json object sang string
    }
    function getDiceHistory(paramObj){
        paramObj.username = $("#inp-username").val().trim();
    }
    function validateDiceHistory(paramObj) {
        if (paramObj.username === "") {
            alert("Username chưa được nhập");
        }else return 1;
    }
    function callAPIDiceHistory(paramObj,paramXmlHttp) {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        paramXmlHttp.open("GET", vBASE_URL + "/dice-history?username=" + paramObj.username, true);
        paramXmlHttp.send();
    }
    function xuLyHienThiDiceHistory(paramXmlHttp) {
        paramXmlHttp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(paramXmlHttp.responseText);
                    var vResponse = JSON.parse(paramXmlHttp.responseText);
                    var vTable =  $("#history-placeholder-table")[0];
                    var vTableHead = vTable.getElementsByTagName("thead")[0];
                    var vTableBody = vTable.getElementsByTagName("tbody")[0];
                    vTableHead.innerHTML = "";
                    vTableBody.innerHTML = "";
                    var vRowHead = vTable.insertRow(0);
                    var vCellDiceHead = vRowHead.insertCell(0);
                    var vCellHead = vRowHead.insertCell(1);
                    vCellDiceHead.innerHTML = "Lượt";
                    vCellHead.innerHTML = "Dice";
                    for (var bI = 0; bI < vResponse.dices.length;bI++){
                        var vRowBody = vTableBody.insertRow(-1);
                        var vCellDiceBody = vRowBody.insertCell(0);
                        var vCellBody = vRowBody.insertCell(1);
                        vCellDiceBody.innerHTML = bI+1;
                        vCellBody.innerHTML = vResponse.dices[bI];
                    }

                }
            }
    }
</script>
</html>